Regenerate.
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
51
52 # The version number of the submission, e.g. 1007.
53 LLVM_SUBMIT_VERSION="${11}"
54
55 # The subversion number of the submission, e.g. 03.
56 LLVM_SUBMIT_SUBVERSION="${12}"
57
58 # The current working directory is where the build will happen. It may already
59 # contain a partial result of an interrupted build, in which case this script
60 # will continue where it left off.
61 DIR=`pwd`
62
63 DARWIN_VERS=`uname -r | sed 's/\..*//'`
64 echo DARWIN_VERS = $DARWIN_VERS
65
66 ################################################################################
67 # Run the build.
68
69 # Create the source tree we'll actually use to build, deleting
70 # tcl since it doesn't actually build properly in a cross environment
71 # and we don't really need it.
72 SRC_DIR=$DIR/src
73 rm -rf $SRC_DIR || exit 1
74 mkdir $SRC_DIR || exit 1
75 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
76 # We can't use the top-level Makefile as-is.  Remove the soft link:
77 rm $SRC_DIR/Makefile || exit 1
78 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
79 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
80
81 # Build the LLVM tree universal.
82 mkdir -p $DIR/obj-llvm || exit 1
83 cd $DIR/obj-llvm || exit 1
84
85 if [ "$ARM_HOSTED_BUILD" = yes ]; then
86   # The cross-tools' build process expects to find an existing cross toolchain
87   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
88   rm -rf $DIR/bin || exit 1
89   mkdir $DIR/bin || exit 1
90   for prog in ar nm ranlib strip lipo ld as ; do
91     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
92     T=`xcrun -sdk $SDKROOT -find ${prog}`
93     echo '#!/bin/sh' > $P || exit 1
94     echo 'exec '$T' "$@"' >> $P || exit 1
95     chmod a+x $P || exit 1
96   done
97   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
98   for prog in gcc g++ ; do
99     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
100     T=`xcrun -find llvm-${prog}`
101     if [ "x$T" = "x" ] ; then
102       T=`xcrun -sdk $SDKROOT -find ${prog}`
103     fi
104     echo '#!/bin/sh' > $P || exit 1
105     echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
106     chmod a+x $P || exit 1
107   done
108
109   PATH=$DIR/bin:$PATH
110 # otherwise, try to use llvm-gcc if it's available
111 elif [ $DARWIN_VERS -gt 9 ]; then
112   # If the user has set CC or CXX, respect their wishes.  If not,
113   # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
114   # available, fall back to usual GCC/G++ default.
115   savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
116   XTMPCC=$(which llvm-gcc)
117   if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
118   XTMPCC=$(which llvm-g++)
119   if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
120   PATH=$savedPATH
121   unset XTMPCC savedPATH
122 fi
123
124 if [ "$ARM_HOSTED_BUILD" = yes ]; then
125   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
126                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
127 else
128   configure_opts="--enable-targets=arm,x86,powerpc,cbe"
129 fi
130
131 if [ \! -f Makefile.config ]; then
132   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
133     --enable-assertions=$LLVM_ASSERTIONS \
134     --enable-optimized=$LLVM_OPTIMIZED \
135     --disable-bindings \
136     || exit 1
137 fi
138
139 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
140
141 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
142     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
143     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
144     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
145 fi
146
147 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
148     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
149 else
150     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
151 fi
152
153 GCC_VER=`cc --version 2>/dev/null | sed 1q`
154
155 if echo "$GCC_VER" | grep GCC > /dev/null; then
156     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
157     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
158     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
159 fi
160
161 JOBS_FLAG=""
162
163 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
164 # already has parallelism and we don't want to make the builders hit swap by
165 # firing off too many gccs at the same time.
166 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
167     # Figure out how many make processes to run.
168     SYSCTL=`sysctl -n hw.activecpu`
169
170     # hw.activecpu only available in 10.2.6 and later
171     if [ -z "$SYSCTL" ]; then
172         SYSCTL=`sysctl -n hw.ncpu`
173     fi
174
175     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
176     # Builders can default to 2, since even if they are single processor,
177     # nothing else is running on the machine.
178     if [ -z "$SYSCTL" ]; then
179         SYSCTL=2
180     fi
181
182     JOBS_FLAG="-j $SYSCTL"
183 fi
184
185 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
186     UNIVERSAL_SDK_PATH=$SDKROOT \
187     NO_RUNTIME_LIBS=1 \
188     DISABLE_EDIS=1 \
189     DEBUG_SYMBOLS=1 \
190     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
191     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
192     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
193     VERBOSE=1
194
195 if [ $? != 0 ] ; then
196     echo "error: LLVM 'make' failed!"
197     exit 1
198 fi 
199
200 ################################################################################
201 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
202 # $DEST_DIR, with occasional 'lipo' commands.
203
204 cd $DEST_DIR || exit 1
205
206 # Clean out DEST_DIR in case -noclean was passed to buildit.
207 rm -rf * || exit 1
208
209 cd $DIR/obj-llvm || exit 1
210
211 # Install the tree into the destination directory.
212 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
213     NO_RUNTIME_LIBS=1 \
214     DISABLE_EDIS=1 \
215     DEBUG_SYMBOLS=1 \
216     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
217     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
218     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
219
220 if ! test $? == 0 ; then
221     echo "error: LLVM 'make install' failed!"
222     exit 1
223 fi 
224
225 # Install Version.h
226 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
227 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
228     LLVM_MINOR_VERSION=0
229 fi
230 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
231 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
232 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
233
234 if [ "x$LLVM_DEBUG" != "x1" ]; then
235     # Strip local symbols from llvm libraries.
236     #
237     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
238     # PPC objects!
239     strip -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
240     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
241         strip -Sxl $f
242     done
243 fi
244
245 # Copy over the tblgen utility.
246 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
247
248 # Remove .dir files 
249 cd $DEST_DIR$DEST_ROOT
250 rm -f bin/.dir etc/llvm/.dir lib/.dir
251
252 # Remove PPC64 fat slices.
253 cd $DEST_DIR$DEST_ROOT/bin
254 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
255     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
256         -exec lipo -extract ppc -extract i386 {} -output {} \;
257 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
258     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
259         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
260 else
261     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
262         -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
263 fi
264
265 # The Hello dylib is an example of how to build a pass. No need to install it.
266 rm $DEST_DIR$DEST_ROOT/lib/LLVMHello.dylib
267
268 # Compress manpages
269 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
270 gzip -f $MDIR/*
271
272 ################################################################################
273 # Create SYM_DIR with information required for debugging.
274
275 # Figure out how many make processes to run.
276 SYSCTL=`sysctl -n hw.activecpu`
277
278 # hw.activecpu only available in 10.2.6 and later
279 if [ -z "$SYSCTL" ]; then
280   SYSCTL=`sysctl -n hw.ncpu`
281 fi
282
283 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
284 # can default to 2, since even if they are single processor, nothing else is
285 # running on the machine.
286 if [ -z "$SYSCTL" ]; then
287   SYSCTL=2
288 fi
289
290 cd $SYM_DIR || exit 1
291
292 # Clean out SYM_DIR in case -noclean was passed to buildit.
293 rm -rf * || exit 1
294
295 # Generate .dSYM files
296 find $DEST_DIR -perm -0111 -type f \
297     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
298     -print | xargs -n 1 -P ${SYSCTL} dsymutil
299
300 # Save .dSYM files and .a archives
301 cd $DEST_DIR || exit 1
302 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
303     | cpio -pdml $SYM_DIR || exit 1
304
305 # Save source files.
306 mkdir $SYM_DIR/src || exit 1
307 cd $DIR || exit 1
308 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
309     | cpio -pdml $SYM_DIR/src || exit 1
310
311 ################################################################################
312 # Install and strip libLTO.dylib
313
314 cd $DEST_DIR$DEST_ROOT
315 if [ "$INSTALL_LIBLTO" = "yes" ]; then
316   DT_HOME="$DEST_DIR/Developer/usr"
317   mkdir -p $DT_HOME/lib
318   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
319
320   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
321   # PPC objects!
322   strip -arch all -Sl $DT_HOME/lib/libLTO.dylib
323 else
324   rm -f lib/libLTO.dylib
325 fi
326 rm -f lib/libLTO.a lib/libLTO.la
327
328 ################################################################################
329 # Remove debugging information from DEST_DIR.
330
331 cd $DIR || exit 1
332
333 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
334 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
335
336 # Strip debugging information from files
337 #
338 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
339 # PPC objects!
340 find $DEST_DIR -perm -0111 -type f \
341     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
342     -print | xargs -n 1 -P ${SYSCTL} strip -arch all -Sl
343
344 chgrp -h -R wheel $DEST_DIR
345 chgrp -R wheel $DEST_DIR
346
347 ################################################################################
348 # Remove the docs directory
349
350 rm -rf $DEST_DIR$DEST_ROOT/docs
351
352 ################################################################################
353 # symlinks so that B&I can find things
354
355 if [ "$INSTALL_LIBLTO" = "yes" ]; then
356   mkdir -p $DEST_DIR/usr/lib/
357   cd $DEST_DIR/usr/lib && \
358     ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib
359 fi
360
361 ################################################################################
362 # w00t! Done!
363
364 exit 0